unit BudgUpdt;

interface

uses
  SysUtils, WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls,
  BudgAcct;

type
  TDialogAcctUpdate = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    EditWithdrawl: TEdit;
    Label1: TLabel;
    EditDeposit: TEdit;
    Label2: TLabel;
    EditAcctName: TEdit;
    Label3: TLabel;
    EditAcctBalance: TEdit;
    Label4: TLabel;
    EditAcctAmtPerPaycheck: TEdit;
    Label5: TLabel;
    Bevel2: TBevel;
    Label6: TLabel;
    EditCreditCard: TEdit;
    Label7: TLabel;
    EditCash: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Execute( acct : TAcct; accts : TAccounts );
  end;

var
  DialogAcctUpdate: TDialogAcctUpdate;

implementation

{$R *.DFM}

procedure TDialogAcctUpdate.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TDialogAcctUpdate.Execute( acct : TAcct; accts : TAccounts );
begin
  EditAcctName.Text := acct.Name;
  EditAcctBalance.Text := FloatToStrF( acct.Balance, ffFixed, 15, 2 );
  EditAcctAmtPerPaycheck.Text := FloatToStrF( acct.AmtPerPaycheck, ffFixed, 15, 2 );
  ShowModal;
  if (ModalResult = mrOk) then
  begin
    acct.Name := EditAcctName.Text;
    acct.Balance := StrToFloat( EditAcctBalance.Text );
    acct.AmtPerPaycheck := StrToFloat( EditAcctAmtPerPaycheck.Text );
    if (EditCreditCard.Text <> '') then
    begin
      acct.Withdrawl( StrToFloat( EditCreditCard.Text ) );
      accts.CreditCard := accts.CreditCard + StrToFloat( EditCreditCard.Text );
    end;
    if (EditCash.Text <> '') then
    begin
      acct.Withdrawl( StrToFloat( EditCash.Text ) );
      accts.Cash := accts.Cash - StrToFloat( EditCash.Text );
    end;
    if (EditWithdrawl.Text <> '') then
      acct.Withdrawl( StrToFloat( EditWithdrawl.Text ) );
    if (EditDeposit.Text <> '') then
      acct.Deposit( StrToFloat( EditDeposit.Text ) );
  end;
  Close;
end;

end.
